package com.trace.ar.drawing.adapter;

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.trace.ar.drawing.ARApp;
import com.trace.ar.drawing.R;
import com.trace.ar.drawing.helper.ObjectBox;
import com.trace.ar.drawing.helper.Utils;
import com.trace.ar.drawing.activity.DetailActivity;

import java.util.List;

public class ViewAllAdapter extends RecyclerView.Adapter<ViewAllAdapter.HomeVH> {


    private Context mCon;
    private List<String> data;



    public ViewAllAdapter(Context mCon, List<String> bitmapList) {
        this.mCon = mCon;
        data = bitmapList;
    }



    @NonNull
    @Override
    public HomeVH onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.adapter_thumb, parent, false);
        return new HomeVH(view);
    }

    @Override
    public void onBindViewHolder(@NonNull HomeVH holder, int position) {

        String name = data.get(position);
        Log.d("---------tt", "---------name=" + name);
        Bitmap bitmap = Utils.loadImageFromAssets(mCon, name);
        holder.previewIm.setImageBitmap(bitmap);

        boolean b = ObjectBox.queryIsLike(name);
        holder.imFavorite.setSelected(b);


        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(mCon, DetailActivity.class);
                intent.putExtra(ARApp.Key_Camera, name);
                mCon.startActivity(intent);
            }
        });

        holder.cardFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                boolean selected = holder.imFavorite.isSelected();
                holder.imFavorite.setSelected(!selected);
                boolean newSelect = holder.imFavorite.isSelected();
                if(newSelect){
                    ObjectBox.insertOrUpdateLike(name);
                }else {
                    ObjectBox.deleteLike(name);

                }
            }
        });
    }

    @Override
    public int getItemCount() {
        return data.size();
    }

    public static class HomeVH extends RecyclerView.ViewHolder {
        private ImageView previewIm, imFavorite;

        private CardView cardView;
        private FrameLayout cardFavorite;

        public HomeVH(@NonNull View itemView) {
            super(itemView);
            previewIm = itemView.findViewById(R.id.imPreview);
            cardView = itemView.findViewById(R.id.card_view);
            cardFavorite = itemView.findViewById(R.id.card_favorite);
            imFavorite = itemView.findViewById(R.id.im_favorite);
        }


    }
}
